# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

# Declaring specific app values (TO CHANGE)
bin_name_string = 'Barrier'
silent_args = '/VERYSILENT /SUPPRESSMSGBOXES /NORESTART'
app_uninstallkey = '{41036EA6-3F7A-4803-8AE0-469E5E91EFCC}_is1'


def install():
    package_version = control.get_software_version()
    bin_name = glob.glob('*%s*.exe' % bin_name_string)[0]

    # Installing the package
    install_exe_if_needed(bin_name
        ,silentflags=silent_args
        ,key=app_uninstallkey
        ,min_version=package_version)

	

def update_package():
    print('Download/Update package content from upstream binary sources')
    import json

    # Getting proxy informations from WAPT settings
    proxy = {}
    if isfile(makepath(application_data(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxy = {'http':proxywapt,'https':proxywapt}

    # Specific app values
    app_name = control.name
    url_api = 'https://api.github.com/repos/debauchee/barrier/releases/latest'
    bin_end = '.exe'

    # Getting latest informations from Github API
    json_load = json.loads(wgets(url_api,proxies=proxy))
    for download in json_load['assets']:
        if download['browser_download_url'].endswith(bin_end):
            url_dl = download['browser_download_url']
            break

    latest_bin = url_dl.split('/')[-1]
    version = (url_dl.split('/')[-2]).replace('v','')

    print('Latest ' + app_name + ' version is: ' + version)
    print('Download url is: ' + url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print('Downloading: ' + latest_bin)
        wget(url_dl,latest_bin,proxies=proxy)

		# Change version of the package
        print('Writing ' + version + '-0 in WAPT\\control')
        from waptpackage import PackageEntry
        pe = PackageEntry()
        pe.load_control_from_wapt(os.getcwd())

        pe.version = version + '-0'
        pe.save_control_to_wapt(os.getcwd())
        print('Update package done. You can now build-upload your package')
    else:
        print('This package is already up-to-date')

    # Deleting outdated binaries
    for bin_in_dir in glob.glob('*.exe') or glob.glob('*.msi'):
        if bin_in_dir != latest_bin :
            print('Outdated binary: ' + bin_in_dir + ' Deleted')
            remove_file(bin_in_dir)

